"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantAvro(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "chromosome",
        "end",
        "length",
        "reference",
        "start",
        "studies",
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "annotation": opencb_2_9_3.VariantAnnotation,
            "studies": opencb_2_9_3.StudyEntry,
            "sv": opencb_2_9_3.StructuralVariation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "type": opencb_2_9_3.VariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.VariantAnnotation": opencb_2_9_3.VariantAnnotation,
            "org.opencb.biodata.models.variant.avro.StudyEntry": opencb_2_9_3.StudyEntry,
            "org.opencb.biodata.models.variant.avro.StructuralVariation": opencb_2_9_3.StructuralVariation,
            "org.opencb.biodata.models.variant.avro.VariantType": opencb_2_9_3.VariantType,
            "org.opencb.biodata.models.variant.avro.VariantAvro": opencb_2_9_3.VariantAvro,
        }

    __slots__ = [
        "alternate",
        "chromosome",
        "end",
        "length",
        "reference",
        "start",
        "studies",
        "type",
        "annotation",
        "id",
        "names",
        "strand",
        "sv",
    ]

    def __init__(
        self,
        alternate,
        chromosome,
        end,
        length,
        reference,
        start,
        studies,
        type,
        annotation=None,
        id=None,
        names=list,
        strand=None,
        sv=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantAvro model.

        :param alternate:
            Alternate allele.
        :type alternate: str
        :param chromosome:
            Chromosome where the genomic variation occurred.
        :type chromosome: str
        :param end:
            Normalized position where the genomic variation ends. <ul> <li>SNVs
            have the same start and end positions</li> <li>Insertions
            end in the first present position: if the last nucleotide
            is inserted in position 9, the end is position 10</li>
            <li>Deletions ends in the last previously present
            position: if the last deleted nucleotide is in position 9,
            the end is position 9</li> </ul>
        :type end: int
        :param length:
            Length of the genomic variation, which depends on the variation type.
            <ul> <li>SNVs have a length of 1 nucleotide</li>
            <li>Indels have the length of the largest allele</li>
            </ul>
        :type length: int
        :param reference:
            Reference allele.
        :type reference: str
        :param start:
            Normalized position where the genomic variation starts. <ul> <li>SNVs
            have the same start and end position</li> <li>Insertions
            start in the last present position: if the first
            nucleotide is inserted in position 6, the start is
            position 5</li> <li>Deletions start in the first
            previously present position: if the first deleted
            nucleotide is in position 6, the start is position 6</li>
            </ul>
        :type start: int
        :param studies:
            Information specific to each study the variant was read from, such as
            samples or statistics.
        :type studies: list[StudyEntry]
        :param type:
            Type of variation: single nucleotide, indel or structural variation.
        :type type: VariantType
        :param annotation:
            Annotations of the genomic variation.
        :type annotation: None | VariantAnnotation
        :param id:
            The variant ID.
        :type id: None | str
        :param names:
            Other names used for this genomic variation.
        :type names: list[str]
        :param strand:
            Reference strand for this variant
        :type strand: None | str
        :param sv:
            Information regarding Structural Variants
        :type sv: None | StructuralVariation
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
